//*****************************************
// AVR ATtiny85 Dekatron(OG4) Spinner Program
// CPU Clock:8MHz
//   iq[Yf[^@UWlgɂj
//
// File Name:port_bit.c
//
//  2016/08/30 New(TAB4)  Taishi
//  2021/02/24 Modify     Taishi Z562S@Ήi_upX fJgj
//  2021/02/25 Modify     Taishi UqɕύX
//  2021/03/24 Modify     Taishi A-102 Ή
//  2021/04/30 Modify     Taishi OG4 Ή
//*****************************************

#include	<avr/io.h>

#include	"tiny85_og4_spinner.h"
#include	"timer.h"
#include	"port_bit.h"


unsigned char	sw[4];							// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏
static	unsigned char	old_sw;
static	unsigned char	sw_continue_count;
static	unsigned char	sw_continue_count_set;	// 20160902
//***************************
//@XCb`̏ݒ
//***************************
void	sw_init(void)
{
	DDRB  &= ~(1 << DDB1);					// Port-B Bit1 : Intput
	PORTB |= (1 << PB1);					// PB1 Pullup
	sw_continue_count = 0;
}
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer0 ̊荞݂gpĂԂKv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		uc = ((~PINB) & SW_RIGHT);							// ]ăXCb`f[^擾
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
			sw[3] = ((sw[0] ^ sw[1]) & ~sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
			sw[3] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
		sw[3] = 0;
	}
}
#define			TMR_LONG			100			// 10mSx100=1Sec ̎Ԗ͒ZԂƂ
#define			TMR_CONTIMUE		100			// 10mSx100=1Sec ꑱ@̊ԊuŁuSWR_ON_CONTINUEvɂȂ
#define			TMR_CONTIMUE2		50			// 10mSx50=500mS ꑱ̂Qxڈȍ~́uSWR_ON_CONTINUEvo^C~OɂȂ
//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer0 ̊荞݂gpĂԂKv
//***************************
unsigned char	get_action_sw(void)
{
	unsigned char	uc=0;

	get_sw();												//@XCb`Ԃ

	if((sw[2] & SW_RIGHT) != 0){							// EXCb`nm̏uԂ̎
		uc |= (SWR_ON_NOW | SWR_ON);
		tim_10ms_swr_continue = TMR_CONTIMUE;
		tim_10ms_swr_length = TMR_LONG;
		sw_continue_count = 1;
	}else if((sw[1] & SW_RIGHT) != 0){						// EXCb`nm̎
		uc |= SWR_ON;
		if(tim_10ms_swr_continue == 0){						// ꑱo^C~O̎
			uc |= SWR_ON_CONTINUE;
			if(sw_continue_count < 2){
				sw_continue_count++;
				tim_10ms_swr_continue = TMR_CONTIMUE;
				sw_continue_count_set = TMR_CONTIMUE2;			// 20160902
			}else{
				tim_10ms_swr_continue = sw_continue_count_set;	// 20160902
				if(5 < sw_continue_count_set){					// 20160902 xȂ
					sw_continue_count_set--;					// 20160902
				}												// 20160902
			}
		}
	}else if((sw[3] & SW_RIGHT) != 0){						// EXCb`ꂽuԂ̎
		if(tim_10ms_swr_length == 0){						// ꂽԂ
			uc |= SWR_OFF_LONG;
		}else{												// ꂽԂZ
			uc |= SWR_OFF_SHORT;
		}
		tim_10ms_swr_continue = 0;
		tim_10ms_swr_length = 0;
		sw_continue_count = 0;
	}else if((sw[1] & SW_RIGHT) == 0){						// EXCb`nee̎
		tim_10ms_swr_continue = 0;
		tim_10ms_swr_length = 0;
		sw_continue_count = 0;
	}

	return(uc);
}

//*****************************************
// XCb`@܂ŉiv[v
//  XCb`͂Ɋ荞݃^C}[gB
//  Timer0 ̊荞݂gpĂԂKv
//*****************************************
void	wait_key_off(void)
{
	while(1){											// rv܂ő҂
		get_action_sw();								//@XCb`Ԃ
		if( (sw[1] & SW_RIGHT) == 0 ){					// ꂽ
			break;
		}
	}
}
//*****************************************
// XCb`@܂ŉiv[v
//  XCb`rbǵA`^Op^C}[Ɂ@荞݂͎gȂ
//  \tgEFA^C}[gp
//*****************************************
void	wait_sw_off(void)
{
	while(1){
		if((PINB & SW_RIGHT) == SW_RIGHT){
			delay_ms(100);												// 100mS Delay
			if((PINB & SW_RIGHT) == SW_RIGHT){
				break;													// {ɗꂽƂ
			}
		}
	}
}

//***************************
//@LED̏ݒ
//***************************
void	led_init(void)
{
	DDRB  |= (1 << DDB0);					// Port-B Bit0 : Output
	PORTB &= ~(1 << PB0);					// PB0 Low
}
//***************************
//@LEDON/OFF
//  F@OneeijAPnmi_j
//***************************
void	led_on_off(unsigned char on)
{
	if(on == 0){
		PORTB &= ~(1 << PB0);					// PB0 Low
	}else{
		PORTB |=  (1 << PB0);					// PB0 High
	}
}

